net.sf.jasperreports.crosstabs

## Interface JRCrosstabBucket

- All Superinterfaces:
    java.lang.Cloneable, JRCloneable
  All Known Implementing Classes:
    JRBaseCrosstabBucket, JRDesignCrosstabBucket

      public interface JRCrosstabBucket
      extends JRCloneable

  Crosstab groups bucketing information interface.

  The bucketing information consists of the grouping expression and sorting information. The buckets can be sorted according to the natural sorting (if the values implement `Comparable`) or using a comparator.

  Version:
    $Id: JRCrosstabBucket.java 6313 2013-07-10 14:38:42Z lucianc $
  Author:
    Lucian Chirita (lucianc@users.sourceforge.net)

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `JRExpression` | `getComparatorExpression()` Returns the comparator expression.
    `JRExpression` | `getExpression()` Returns the grouping expression.
    `BucketOrder` | `getOrder()` Returns the bucket sorting type.
    `JRExpression` | `getOrderByExpression()` Returns an expression that provides order by values for group buckets.
    `SortOrderEnum` | `getOrderValue()` Deprecated. replaced by `getOrder()`
    `java.lang.Class<?>` | `getValueClass()` Returns the class of the bucket value.
    `java.lang.String` | `getValueClassName()` Returns the string name of the bucket value class.

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRCloneable

      `clone`

- - ### Method Detail

    - #### getValueClass

          java.lang.Class<?> getValueClass()

      Returns the class of the bucket value. Any class is allowed as long as it is in the classpath at compile and run time.
      Returns:
        a `Class` instance representing the bucket value class

    - #### getValueClassName

          java.lang.String getValueClassName()

      Returns the string name of the bucket value class.

    - #### getOrderValue

          @Deprecated
          SortOrderEnum getOrderValue()

      Deprecated. replaced by `getOrder()`
      Returns the bucket sorting type.

      The possible values are:

      - `SortOrderEnum.ASCENDING`
      - `SortOrderEnum.DESCENDING`
      Returns:
        the bucket sorting type

    - #### getOrder

          BucketOrder getOrder()

      Returns the bucket sorting type.

      The possible values are:

      - `BucketOrder.ASCENDING`
      - `BucketOrder.DESCENDING`
      - `BucketOrder.NONE`
      Returns:
        the bucket sorting type
      See Also:
        `getComparatorExpression()`

    - #### getExpression

          JRExpression getExpression()

      Returns the grouping expression.
      Returns:
        the grouping expression

    - #### getComparatorExpression

          JRExpression getComparatorExpression()

      Returns the comparator expression.

      The result of this expression is used to sort the buckets, in ascending or descending order (given by `getOrderValue()`. If the bucket has an order by expression, the comparator will be used to compare values as produced by that expression. If no comparator expression is specified, the natural order will be used.

      Returns:
        the comparator expression
      See Also:
        `getOrderByExpression()`

    - #### getOrderByExpression

          JRExpression getOrderByExpression()

      Returns an expression that provides order by values for group buckets. If not set, the bucket values as returned by `getExpression()` are used to order the buckets.

      The expression is evaluated in the context of the crosstab group and can reference measure variables, which evaluate to group totals.

      Returns:
        the order by value expression for the group bucket

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com